local TEXT_MOD_NAME = "Gwain Warriors 064"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_GEO009_MODEL = smlua_model_util_get_id("geo_009_geo") -- Located in "actors"
local E_MODEL_COSTUME_GEO001 = smlua_model_util_get_id("geo_001_geo") -- 001 Costume
local E_MODEL_COSTUME_GEOCLASSIC = smlua_model_util_get_id("geo_classic_geo") -- Classic Remix Costume

local TEX_COSTUME_LIFE_ICON = get_texture_info("geo-icon") -- Replace with the appropriate life icon texture if different
local TEX_COSTUME2_LIFE_ICON = get_texture_info("classicgeo-icon") -- Replace with the appropriate life icon texture if different
local TEX_GEO_LIFE_ICON = get_texture_info("geo-icon") -- Located in "textures"
local TEX_GEO_COURSE_TOP = get_texture_info("gwain-course-top")
local TEX_GEO_COURSE_BOTTOM = get_texture_info("gwain-course-bottom")
--local TEX_CUSTOM_STAR_ICON = get_texture_info("exclamation-icon") -- Located in "textures"

local GEOCourseInfo = {
    top = TEX_GEO_COURSE_TOP,
    bottom = TEX_GEO_COURSE_BOTTOM,
}

-- All Located in "sound"
local VOICETABLE_GEO = {
    [CHAR_SOUND_ATTACKED] = {"placehld_attacked1.ogg", "placehld_attacked2.ogg", "placehld_attacked3.ogg"},
    [CHAR_SOUND_COUGHING1] = "placehld_cough.ogg",
    [CHAR_SOUND_COUGHING2] = "placehld_cough.ogg",
    [CHAR_SOUND_COUGHING3] = "placehld_cough.ogg",
    [CHAR_SOUND_DOH] = "placehld_doh.ogg",
    [CHAR_SOUND_DROWNING] = "placehld_drown.ogg",
    [CHAR_SOUND_DYING] = "placehld_dead.ogg",
    [CHAR_SOUND_EEUH] = "placehld_hit.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "placehld_groundpound.ogg",
    [CHAR_SOUND_HAHA] = "placehld_haha.ogg",
    [CHAR_SOUND_HAHA_2] = "placehld_haha.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "placehld_starget.ogg",
    [CHAR_SOUND_HOOHOO] = "placehld_hoohoo.ogg",
    [CHAR_SOUND_HRMM] = "placehld_hrmm.ogg",
    [CHAR_SOUND_IMA_TIRED] = "placehld_tired.ogg",
    [CHAR_SOUND_MAMA_MIA] = "placehld_nope.ogg",
    [CHAR_SOUND_LETS_A_GO] = "placehld_levelstart.ogg",
    [CHAR_SOUND_ON_FIRE] = "placehld_burning.ogg",
    [CHAR_SOUND_OOOF] = "placehld_ooof.ogg",
    [CHAR_SOUND_OOOF2] = "placehld_ooof2.ogg",
    [CHAR_SOUND_PANTING] = "placehld_lowhealth.ogg",
    [CHAR_SOUND_PANTING_COLD] = "placehld_cold.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "placehld_punch_hoo.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "placehld_punch_wah.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "placehld_punch_yah.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = {"placehld_throw1.ogg", "placehld_throw2.ogg"},
    [CHAR_SOUND_SNORING1] = "placehld_snore1.ogg",
    [CHAR_SOUND_SNORING2] = "placehld_groundpound.ogg",
    [CHAR_SOUND_SNORING3] = {"placehld_groundpound.ogg", "placehld_snore1.ogg", "placehld_snore3.ogg"},
    [CHAR_SOUND_TWIRL_BOUNCE] = "placehld_spinjump.ogg",
    [CHAR_SOUND_UH] = "placehld_uh.ogg",
    [CHAR_SOUND_UH2] = "placehld_uh.ogg",
    [CHAR_SOUND_UH2_2] = "placehld_uh2_2.ogg",
    [CHAR_SOUND_WAAAOOOW] = "placehld_falling.ogg",
    [CHAR_SOUND_WAH2] = "placehld_jump1i.ogg",
    [CHAR_SOUND_WHOA] = "placehld_woah.ogg",
    [CHAR_SOUND_YAHOO] = "placehld_longjump.ogg",
    [CHAR_SOUND_YAWNING] = "placehld_yawn.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { "placehld_triplejump.ogg", "placehld_jump3.ogg", "placehld_longjump.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = { "placehld_jump2.ogg", "placehld_jump4.ogg", "placehld_jump6.ogg"},
    [CHAR_SOUND_HELLO] = "placehld_hello.ogg"
}

-- All Located in "actors"
local CAPTABLE_GEO009 = {
   normal = smlua_model_util_get_id("visor_009_geo"),
    wing = smlua_model_util_get_id("visorwings_009_geo"),
    metal = smlua_model_util_get_id("visormetal_009_geo"),
    metalWing = smlua_model_util_get_id("visorwingsmetal_009_geo"),
}

local CAPTABLE_GEO001 = {
   normal = smlua_model_util_get_id("visor001_geo"),
    wing = smlua_model_util_get_id("visorwings001_geo"),
    metal = smlua_model_util_get_id("visormetal_009_geo"),
    metalWing = smlua_model_util_get_id("visorwingsmetal_009_geo"),
}

local CAPTABLE_GEOCLASSIC = {
   normal = smlua_model_util_get_id("visorclas_geo"),
    wing = smlua_model_util_get_id("visorclaswing_geo"),
    metal = smlua_model_util_get_id("visorclasmetal_geo"),
    metalWing = smlua_model_util_get_id("visorclaswingmetal_geo"),
}

--local E_MODEL_CUSTOM_STAR = smlua_model_util_get_id("custom_model_star_geo") -- Located in "actors"



--
-- All Located in "textures"
local healthMeter = {
    label = {
        left = get_texture_info("gwainhp-half1"),
        right = get_texture_info("gwainhp-half2"),
    },
    pie = {
        [1] = get_texture_info("gwainhp-one"),
        [2] = get_texture_info("gwainhp-two"),
        [3] = get_texture_info("gwainhp-three"),
        [4] = get_texture_info("gwainhp-four"),
        [5] = get_texture_info("gwainhp-five"),
        [6] = get_texture_info("gwainhp-six"),
        [7] = get_texture_info("gwainhp-seven"),
        [8] = get_texture_info("gwainhp-eight"),
    }
}


--[[
    Note: If there are some functionalities you don't care
    to add such as palettes, you can freely remove the function
    for it, the only function you require is character_add
]]

local CSloaded = false
local function on_character_select_load()
    CT_GEO = _G.charSelect.character_add("Geo", "The hero of this story and a well-rounded mute. With his white hair and charming personality, he seeks to aid the princess and protect her at every turn as her hired bodyguard. Though beneath the mask hides his biggest secret...", "B. Bones Johnson/GeoExe", {r = 255, g = 255, b = 255}, E_MODEL_GEO009_MODEL, CT_LUIGI, TEX_GEO_LIFE_ICON)
	
	
	ALT_GEO = _G.charSelect.character_add_costume(

        CT_GEO,                     -- Original Character Number

        "Geo (Alt Style)",                  -- Name (Save Name)

        "This is an alternate costume for Geo, based on one of his first outfits.", -- Description (Table containing Strings)

        "B. Bones Johnson/GeoExe",              -- Credit

        {r = 255, g = 255, b = 255},                                  -- Color (nil)

        E_MODEL_COSTUME_GEO001,              -- Model Info

        CT_LUIGI,                             -- Forced Character

        TEX_COSTUME_LIFE_ICON                 -- Life Icon

    )
	
	
	REMIX_GEO =	_G.charSelect.character_add_costume(

        CT_GEO,                     -- Original Character Number

        "Geo (Remix Style)",                  -- Name (Save Name)

        "A Bonus Style that takes traits from the two previous costumes and combines them!", -- Description (Table containing Strings)

        "B. Bones Johnson/GeoExe",              -- Credit

        {r = 255, g = 255, b = 255},                                  -- Color (nil)

        E_MODEL_COSTUME_GEOCLASSIC,              -- Model Info

        CT_LUIGI,                             -- Forced Character

        TEX_COSTUME2_LIFE_ICON                 -- Life Icon

    )
	
	
    _G.charSelect.character_add_caps(E_MODEL_GEO009_MODEL, CAPTABLE_GEO009)
	_G.charSelect.character_add_caps(E_MODEL_COSTUME_GEO001, CAPTABLE_GEO001)
	_G.charSelect.character_add_caps(E_MODEL_COSTUME_GEOCLASSIC, CAPTABLE_GEOCLASSIC)
    _G.charSelect.character_add_voice(E_MODEL_GEO009_MODEL, VOICETABLE_GEO)
	_G.charSelect.character_add_voice(E_MODEL_COSTUME_GEO001, VOICETABLE_GEO)
	_G.charSelect.character_add_voice(E_MODEL_COSTUME_GEOCLASSIC, VOICETABLE_GEO)
    _G.charSelect.character_add_health_meter(CT_GEO, healthMeter)
	_G.charSelect.character_add_costume_health_meter(CT_GEO, ALT_GEO, healthMeter)
	_G.charSelect.character_add_costume_health_meter(CT_GEO, REMIX_GEO, healthMeter)
	_G.charSelect.character_add_course_texture(CT_GEO, GEOCourseInfo)
	_G.charSelect.character_add_costume_course_texture(CT_GEO, ALT_GEO, GEOCourseInfo)
	_G.charSelect.character_add_costume_course_texture(CT_GEO, REMIX_GEO, GEOCourseInfo)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_GEO then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_GEO then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)