if not _G.charSelectExists then return end

local E_MODEL_AMI009 = smlua_model_util_get_id('ami_009_geo') --Main Skin
local E_MODEL_AMI001 = smlua_model_util_get_id('ami_001_geo') --001 Costume
local E_MODEL_AMICLASSIC = smlua_model_util_get_id('ami_classic_geo') --Classic Remix Costume

local TEX_AMI_LIFE_ICON = get_texture_info('ami-icon') -- Located in 'textures'
local TEX_AMI_COSTUME_ICON = get_texture_info('ami-icon') -- Located in 'textures'
local TEX_AMI_CLASSIC_ICON = get_texture_info('classicami-icon') -- Located in 'textures'
local TEX_AMI_COURSE_TOP = get_texture_info("gwain-course-top")
local TEX_AMI_COURSE_BOTTOM = get_texture_info("gwain-course-bottom")

--All Located in 'sound'
--Global Placeholder Table (uncomment to switch, then comment the other one)
local VOICETABLE_AMI = {
    [CHAR_SOUND_ATTACKED] = {"placehld_attacked1.ogg", "placehld_attacked2.ogg", "placehld_attacked3.ogg"},
    [CHAR_SOUND_COUGHING1] = "placehld_cough.ogg",
    [CHAR_SOUND_COUGHING2] = "placehld_cough.ogg",
    [CHAR_SOUND_COUGHING3] = "placehld_cough.ogg",
    [CHAR_SOUND_DOH] = "placehld_doh.ogg",
    [CHAR_SOUND_DROWNING] = "placehld_drown.ogg",
    [CHAR_SOUND_DYING] = "placehld_dead.ogg",
    [CHAR_SOUND_EEUH] = "placehld_hit.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "placehld_groundpound.ogg",
    [CHAR_SOUND_HAHA] = "placehld_haha.ogg",
    [CHAR_SOUND_HAHA_2] = "placehld_haha.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "placehld_starget.ogg",
    [CHAR_SOUND_HOOHOO] = "placehld_hoohoo.ogg",
    [CHAR_SOUND_HRMM] = "placehld_hrmm.ogg",
    [CHAR_SOUND_IMA_TIRED] = "placehld_tired.ogg",
    [CHAR_SOUND_MAMA_MIA] = "placehld_nope.ogg",
    [CHAR_SOUND_LETS_A_GO] = "placehld_levelstart.ogg",
    [CHAR_SOUND_ON_FIRE] = "placehld_burning.ogg",
    [CHAR_SOUND_OOOF] = "placehld_ooof.ogg",
    [CHAR_SOUND_OOOF2] = "placehld_ooof2.ogg",
    [CHAR_SOUND_PANTING] = "placehld_lowhealth.ogg",
    [CHAR_SOUND_PANTING_COLD] = "placehld_cold.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "placehld_punch_hoo.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "placehld_punch_wah.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "placehld_punch_yah.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = {"placehld_throw1.ogg", "placehld_throw2.ogg"},
    [CHAR_SOUND_SNORING1] = "placehld_snore1.ogg",
    [CHAR_SOUND_SNORING2] = "placehld_groundpound.ogg",
    [CHAR_SOUND_SNORING3] = {"placehld_groundpound.ogg", "placehld_snore1.ogg", "placehld_snore3.ogg"},
    [CHAR_SOUND_TWIRL_BOUNCE] = "placehld_spinjump.ogg",
    [CHAR_SOUND_UH] = "placehld_uh.ogg",
    [CHAR_SOUND_UH2] = "placehld_uh.ogg",
    [CHAR_SOUND_UH2_2] = "placehld_uh2_2.ogg",
    [CHAR_SOUND_WAAAOOOW] = "placehld_falling.ogg",
    [CHAR_SOUND_WAH2] = "placehld_jump1i.ogg",
    [CHAR_SOUND_WHOA] = "placehld_woah.ogg",
    [CHAR_SOUND_YAHOO] = "placehld_longjump.ogg",
    [CHAR_SOUND_YAWNING] = "placehld_yawn.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { "placehld_triplejump.ogg", "placehld_jump3.ogg", "placehld_longjump.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = { "placehld_jump2.ogg", "placehld_jump4.ogg", "placehld_jump6.ogg"},
    [CHAR_SOUND_HELLO] = "placehld_hello.ogg"
}



--[[Proper Voice Table will be used later
local VOICETABLE_AMI = {
    [CHAR_SOUND_ATTACKED] = {"ami_ouch.ogg"},
    [CHAR_SOUND_COUGHING1] = "ami_cough.ogg",
    [CHAR_SOUND_COUGHING2] = "ami_cough.ogg",
    [CHAR_SOUND_COUGHING3] = "ami_cough.ogg",
    [CHAR_SOUND_DOH] = "ami_omph2.ogg",
    [CHAR_SOUND_DROWNING] = "ami_drowning.ogg",
    [CHAR_SOUND_DYING] = "ami_dead.ogg",
    [CHAR_SOUND_EEUH] = "ami_eeyuh.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "ami_struggle.ogg",
    [CHAR_SOUND_HAHA] = "ami_haha.ogg",
    [CHAR_SOUND_HAHA_2] = "ami_haha.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "ami_herewego.ogg",
    [CHAR_SOUND_HOOHOO] = "ami_hoo.ogg",
    [CHAR_SOUND_HRMM] = "ami_mmph.ogg",
    [CHAR_SOUND_IMA_TIRED] = "ami_imtired.ogg",
    [CHAR_SOUND_MAMA_MIA] = "ami_mamamia.ogg",
    [CHAR_SOUND_LETS_A_GO] = "ami_letsgo.ogg",
    [CHAR_SOUND_ON_FIRE] = "ami_burning.ogg",
    [CHAR_SOUND_OOOF] = "ami_doh.ogg",
    [CHAR_SOUND_OOOF2] = "ami_oof2.ogg",
    [CHAR_SOUND_PANTING] = "ami_panting.ogg",
    [CHAR_SOUND_PANTING_COLD] = "ami_panting.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "ami_hookick.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "ami_ya.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "ami_yah.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = {"ami_bye.ogg", "ami_bye2.ogg"},
    [CHAR_SOUND_SNORING1] = "ami_snore1.ogg",
    [CHAR_SOUND_SNORING2] = "ami_snore2.ogg",
    [CHAR_SOUND_SNORING3] = {"ami_snore1.ogg", "ami_snore2.ogg", "ami_snore3.ogg"},
    [CHAR_SOUND_TWIRL_BOUNCE] = "ami_boing.ogg",
    [CHAR_SOUND_UH] = "ami_oof.ogg",
    [CHAR_SOUND_UH2] = "ami_woob.ogg",
    [CHAR_SOUND_UH2_2] = "ami_oof.ogg",
    [CHAR_SOUND_WAAAOOOW] = "ami_falling.ogg",
    [CHAR_SOUND_WAH2] = "ami_woob.ogg",
    [CHAR_SOUND_WHOA] = "ami_woah.ogg",
    [CHAR_SOUND_YAHOO] = "ami_yahoo.ogg",
    [CHAR_SOUND_YAWNING] = "ami_yawn.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { "ami_yahoo.ogg", "ami_wahaa.ogg", "ami_yipee.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = { "ami_ya.ogg", "ami_yah.ogg"},
    [CHAR_SOUND_HELLO] = "ami_hello.ogg",
	[CHAR_SOUND_OKEY_DOKEY] = "ami_okdokie.ogg"
}
]]

local healthMeter = {
    label = {
        left = get_texture_info("gwainhp-half1"),
        right = get_texture_info("gwainhp-half2"),
    },
    pie = {
        [1] = get_texture_info("gwainhp-one"),
        [2] = get_texture_info("gwainhp-two"),
        [3] = get_texture_info("gwainhp-three"),
        [4] = get_texture_info("gwainhp-four"),
        [5] = get_texture_info("gwainhp-five"),
        [6] = get_texture_info("gwainhp-six"),
        [7] = get_texture_info("gwainhp-seven"),
        [8] = get_texture_info("gwainhp-eight"),
    }
}

local AMICourseInfo = {
    top = TEX_AMI_COURSE_TOP,
    bottom = TEX_AMI_COURSE_BOTTOM,
}

-- All Located in 'actors'
local CAPTABLE_AMI009 = {
   normal = smlua_model_util_get_id('headband_009_geo'),
    wing = smlua_model_util_get_id('headband_wing_009_geo'),
    metal = smlua_model_util_get_id('headband_metal_009_geo'),
    metalWing = smlua_model_util_get_id('headband_wingmetal_009_geo'),
}

local CAPTABLE_AMI001 = {
   normal = smlua_model_util_get_id('headband_001_geo'),
    wing = smlua_model_util_get_id('headband_wing_001_geo'),
    metal = smlua_model_util_get_id('headband_metal_009_geo'),
    metalWing = smlua_model_util_get_id('headband_wingmetal_009_geo'),
}

local CAPTABLE_AMICLASSIC = {
   normal = smlua_model_util_get_id('headband_classic_geo'),
    wing = smlua_model_util_get_id('headband_wing_classic_geo'),
    metal = smlua_model_util_get_id('headband_metal_classic_geo'),
    metalWing = smlua_model_util_get_id('headband_wingmetal_classic_geo'),
}

local charSelectLoaded = false
local function on_character_select_load()
CT_AMI = _G.charSelect.character_add('Ami', "A lovable and sassy little love elemental, and heir to the throne of Teora. Princess Ami is a mischievous rebel who often paves the way for her own story by frequently putting herself in harm's way. Thankfully, due in part to the appearance of her bodyguard, she has slowly begun to prove her independence.", 'B. Bones Johnson/GeoExe', {r = 254, g = 209, b = 220}, E_MODEL_AMI009, CT_LUIGI, TEX_AMI_LIFE_ICON)
ALT_AMI = _G.charSelect.character_add_costume(

        CT_AMI,                     -- Original Character Number

        'Ami (Alt Style)',                  -- Name (Save Name)

        "This is an alternate costume for Ami, based on one of her first outfits.", -- Description (Table containing Strings)

        'B. Bones Johnson/GeoExe',              -- Credit

        {r = 254, g = 209, b = 220},                                  -- Color (nil)

        E_MODEL_AMI001,              -- Model Info

        CT_LUIGI,                             -- Forced Character

        TEX_AMI_COSTUME_ICON                 -- Life Icon

    )
	
REMIX_AMI =	_G.charSelect.character_add_costume(

        CT_AMI,                     -- Original Character Number

        'Ami (Remix Style)',                  -- Name (Save Name)

        "A Bonus Style that takes traits from the two previous costumes and combines them!", -- Description (Table containing Strings)

        'B. Bones Johnson/GeoExe',              -- Credit

        {r = 254, g = 209, b = 220},                                  -- Color (nil)

        E_MODEL_AMICLASSIC,              -- Model Info

        CT_LUIGI,                             -- Forced Character

        TEX_AMI_CLASSIC_ICON                 -- Life Icon

    )
	
_G.charSelect.character_add_caps(E_MODEL_AMI009, CAPTABLE_AMI009)
_G.charSelect.character_add_caps(E_MODEL_AMI001, CAPTABLE_AMI001)
_G.charSelect.character_add_caps(E_MODEL_AMICLASSIC, CAPTABLE_AMICLASSIC)
_G.charSelect.character_add_voice(E_MODEL_AMI009, VOICETABLE_AMI)
_G.charSelect.character_add_voice(E_MODEL_AMI001, VOICETABLE_AMI)
_G.charSelect.character_add_voice(E_MODEL_AMICLASSIC, VOICETABLE_AMI)
_G.charSelect.character_add_health_meter(CT_AMI, healthMeter)
_G.charSelect.character_add_costume_health_meter(CT_AMI, ALT_AMI, healthMeter)
_G.charSelect.character_add_costume_health_meter(CT_AMI, REMIX_AMI, healthMeter)
_G.charSelect.character_add_course_texture(CT_AMI, AMICourseInfo)
_G.charSelect.character_add_costume_course_texture(CT_AMI, ALT_AMI, AMICourseInfo)
_G.charSelect.character_add_costume_course_texture(CT_AMI, REMIX_AMI, AMICourseInfo)

	    charSelectLoaded = true
end
	
	local function on_character_sound(m, sound)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_AMI then return _G.charSelect.voice.sound(m, sound) end
end
local function on_character_snore(m)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_AMI then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)