if not _G.charSelectExists then return end

local E_MODEL_DEVA009 = smlua_model_util_get_id("deva_009_geo") --Main Skin
local E_MODEL_DEVA001 = smlua_model_util_get_id("deva_001_geo") --Main Skin

local TEX_DEVA_LIFE_ICON = get_texture_info("deva-icon") -- Located in "textures"}

local TEX_DEVA_COURSE_TOP = get_texture_info("gwain-course-top")
local TEX_DEVA_COURSE_BOTTOM = get_texture_info("gwain-course-bottom")

--All Located in "sound"
local VOICETABLE_DEVA = {
    [CHAR_SOUND_ATTACKED] = {"placehld_attacked1.ogg", "placehld_attacked2.ogg", "placehld_attacked3.ogg"},
    [CHAR_SOUND_COUGHING1] = "placehld_cough.ogg",
    [CHAR_SOUND_COUGHING2] = "placehld_cough.ogg",
    [CHAR_SOUND_COUGHING3] = "placehld_cough.ogg",
    [CHAR_SOUND_DOH] = "placehld_doh.ogg",
    [CHAR_SOUND_DROWNING] = "placehld_drown.ogg",
    [CHAR_SOUND_DYING] = "placehld_dead.ogg",
    [CHAR_SOUND_EEUH] = "placehld_hit.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "placehld_groundpound.ogg",
    [CHAR_SOUND_HAHA] = "placehld_haha.ogg",
    [CHAR_SOUND_HAHA_2] = "placehld_haha.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "placehld_starget.ogg",
    [CHAR_SOUND_HOOHOO] = "placehld_hoohoo.ogg",
    [CHAR_SOUND_HRMM] = "placehld_hrmm.ogg",
    [CHAR_SOUND_IMA_TIRED] = "placehld_tired.ogg",
    [CHAR_SOUND_MAMA_MIA] = "placehld_nope.ogg",
    [CHAR_SOUND_LETS_A_GO] = "placehld_levelstart.ogg",
    [CHAR_SOUND_ON_FIRE] = "placehld_burning.ogg",
    [CHAR_SOUND_OOOF] = "placehld_ooof.ogg",
    [CHAR_SOUND_OOOF2] = "placehld_ooof2.ogg",
    [CHAR_SOUND_PANTING] = "placehld_lowhealth.ogg",
    [CHAR_SOUND_PANTING_COLD] = "placehld_cold.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "placehld_punch_hoo.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "placehld_punch_wah.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "placehld_punch_yah.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = {"placehld_throw1.ogg", "placehld_throw2.ogg"},
    [CHAR_SOUND_SNORING1] = "placehld_snore1.ogg",
    [CHAR_SOUND_SNORING2] = "placehld_groundpound.ogg",
    [CHAR_SOUND_SNORING3] = {"placehld_groundpound.ogg", "placehld_snore1.ogg", "placehld_snore3.ogg"},
    [CHAR_SOUND_TWIRL_BOUNCE] = "placehld_spinjump.ogg",
    [CHAR_SOUND_UH] = "placehld_uh.ogg",
    [CHAR_SOUND_UH2] = "placehld_uh.ogg",
    [CHAR_SOUND_UH2_2] = "placehld_uh2_2.ogg",
    [CHAR_SOUND_WAAAOOOW] = "placehld_falling.ogg",
    [CHAR_SOUND_WAH2] = "placehld_jump1i.ogg",
    [CHAR_SOUND_WHOA] = "placehld_woah.ogg",
    [CHAR_SOUND_YAHOO] = "placehld_longjump.ogg",
    [CHAR_SOUND_YAWNING] = "placehld_yawn.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { "placehld_triplejump.ogg", "placehld_jump3.ogg", "placehld_longjump.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = { "placehld_jump2.ogg", "placehld_jump4.ogg", "placehld_jump6.ogg"},
    [CHAR_SOUND_HELLO] = "placehld_hello.ogg"
}

-- All Located in "actors"
local CAPTABLE_DEVA009 = {
   normal = smlua_model_util_get_id("deva_cap_geo"),
    wing = smlua_model_util_get_id("deva_wingcap_geo"),
    metal = smlua_model_util_get_id("deva_metalcap_geo"),
    metalWing = smlua_model_util_get_id("deva_wingmetalcap_geo"),
}

local healthMeter = {
    label = {
        left = get_texture_info("gwainhp-half1"),
        right = get_texture_info("gwainhp-half2"),
    },
    pie = {
        [1] = get_texture_info("gwainhp-one"),
        [2] = get_texture_info("gwainhp-two"),
        [3] = get_texture_info("gwainhp-three"),
        [4] = get_texture_info("gwainhp-four"),
        [5] = get_texture_info("gwainhp-five"),
        [6] = get_texture_info("gwainhp-six"),
        [7] = get_texture_info("gwainhp-seven"),
        [8] = get_texture_info("gwainhp-eight"),
    }
}

local DEVACourseInfo = {
    top = TEX_DEVA_COURSE_TOP,
    bottom = TEX_DEVA_COURSE_BOTTOM,
}

local CSloaded = false
local function on_character_select_load()
CT_DEVA = _G.charSelect.character_add("Deva", "As her name implies, this tsundere has a mean attitude, but just like her cousin, her cold heart is actually warm and inviting. Beneath her thick skin and sharp jabs lies a sweet girl who prides herself on helping her friends. Though it's hard to see under the many layers of rage and jealousy.", "B. Bones Johnson/GeoExe", {r = 127, g = 229, b = 254}, E_MODEL_DEVA009, CT_LUIGI, TEX_DEVA_LIFE_ICON)
ALT_DEVA = _G.charSelect.character_add_costume(

        CT_DEVA,                     -- Original Character Number

        "Deva (Alt Style)",                  -- Name (Save Name)

        "This is an alternate costume for Deva, based on an outfit she wore in her debut episode.", -- Description (Table containing Strings)

        "B. Bones Johnson/GeoExe",              -- Credit

        {r = 125, g = 229, b = 251},                                  -- Color (nil)

        E_MODEL_DEVA001,              -- Model Info

        CT_LUIGI,                             -- Forced Character

        TEX_DEVA_LIFE_ICON                 -- Life Icon

    )
_G.charSelect.character_add_caps(E_MODEL_DEVA009, CAPTABLE_DEVA009)
_G.charSelect.character_add_caps(E_MODEL_DEVA001, CAPTABLE_DEVA009)
_G.charSelect.character_add_voice(E_MODEL_DEVA009, VOICETABLE_DEVA)
_G.charSelect.character_add_voice(E_MODEL_DEVA001, VOICETABLE_DEVA)
_G.charSelect.character_add_health_meter(CT_DEVA, healthMeter)
_G.charSelect.character_add_costume_health_meter(CT_DEVA, ALT_DEVA, healthMeter)
_G.charSelect.character_add_course_texture(CT_DEVA, DEVACourseInfo)
_G.charSelect.character_add_costume_course_texture(CT_DEVA, ALT_DEVA, DEVACourseInfo)

	charSelectLoaded = true
	end
	
	
	local function on_character_sound(m, sound)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_DEVA then return _G.charSelect.voice.sound(m, sound) end
end
local function on_character_snore(m)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_DEVA then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)