if not _G.charSelectExists then return end

local E_MODEL_LANNEY009 = smlua_model_util_get_id("lanney_009_geo") --Main Skin
local E_MODEL_LANNEY001 = smlua_model_util_get_id("lanney_001_geo") --Alt Skin

local TEX_LANNEY_LIFE_ICON = get_texture_info("lanney-icon") -- Located in "textures"
local TEX_LANNEY_ALT_ICON = get_texture_info("lanney-icon-alt")
local TEX_LANNEY_COURSE_TOP = get_texture_info("gwain-course-top")
local TEX_LANNEY_COURSE_BOTTOM = get_texture_info("gwain-course-bottom")

-- All Located in "sound"
local VOICETABLE_LANNEY = {
    [CHAR_SOUND_ATTACKED] = {"placehld_attacked1.ogg", "placehld_attacked2.ogg", "placehld_attacked3.ogg"},
    [CHAR_SOUND_COUGHING1] = "placehld_cough.ogg",
    [CHAR_SOUND_COUGHING2] = "placehld_cough.ogg",
    [CHAR_SOUND_COUGHING3] = "placehld_cough.ogg",
    [CHAR_SOUND_DOH] = "placehld_doh.ogg",
    [CHAR_SOUND_DROWNING] = "placehld_drown.ogg",
    [CHAR_SOUND_DYING] = "placehld_dead.ogg",
    [CHAR_SOUND_EEUH] = "placehld_hit.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "placehld_groundpound.ogg",
    [CHAR_SOUND_HAHA] = "placehld_haha.ogg",
    [CHAR_SOUND_HAHA_2] = "placehld_haha.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "placehld_starget.ogg",
    [CHAR_SOUND_HOOHOO] = "placehld_hoohoo.ogg",
    [CHAR_SOUND_HRMM] = "placehld_hrmm.ogg",
    [CHAR_SOUND_IMA_TIRED] = "placehld_tired.ogg",
    [CHAR_SOUND_MAMA_MIA] = "placehld_nope.ogg",
    [CHAR_SOUND_LETS_A_GO] = "placehld_levelstart.ogg",
    [CHAR_SOUND_ON_FIRE] = "placehld_burning.ogg",
    [CHAR_SOUND_OOOF] = "placehld_ooof.ogg",
    [CHAR_SOUND_OOOF2] = "placehld_ooof2.ogg",
    [CHAR_SOUND_PANTING] = "placehld_lowhealth.ogg",
    [CHAR_SOUND_PANTING_COLD] = "placehld_cold.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "placehld_punch_hoo.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "placehld_punch_wah.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "placehld_punch_yah.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = {"placehld_throw1.ogg", "placehld_throw2.ogg"},
    [CHAR_SOUND_SNORING1] = "placehld_snore1.ogg",
    [CHAR_SOUND_SNORING2] = "placehld_groundpound.ogg",
    [CHAR_SOUND_SNORING3] = {"placehld_groundpound.ogg", "placehld_snore1.ogg", "placehld_snore3.ogg"},
    [CHAR_SOUND_TWIRL_BOUNCE] = "placehld_spinjump.ogg",
    [CHAR_SOUND_UH] = "placehld_uh.ogg",
    [CHAR_SOUND_UH2] = "placehld_uh.ogg",
    [CHAR_SOUND_UH2_2] = "placehld_uh2_2.ogg",
    [CHAR_SOUND_WAAAOOOW] = "placehld_falling.ogg",
    [CHAR_SOUND_WAH2] = "placehld_jump1i.ogg",
    [CHAR_SOUND_WHOA] = "placehld_woah.ogg",
    [CHAR_SOUND_YAHOO] = "placehld_longjump.ogg",
    [CHAR_SOUND_YAWNING] = "placehld_yawn.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { "placehld_triplejump.ogg", "placehld_jump3.ogg", "placehld_longjump.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = { "placehld_jump2.ogg", "placehld_jump4.ogg", "placehld_jump6.ogg"},
    [CHAR_SOUND_HELLO] = "placehld_hello.ogg"
}

-- All Located in "actors"
local CAPTABLE_LANNEY009 = {
   normal = smlua_model_util_get_id("lancap_009_geo"),
    wing = smlua_model_util_get_id("lancap_wing_009_geo"),
    metal = smlua_model_util_get_id("lancap_metal_009_geo"),
    metalWing = smlua_model_util_get_id("lancap_wingmetal_009_geo"),
}

local CAPTABLE_LANNEY001 = {
   normal = smlua_model_util_get_id("lanhat_geo"),
    wing = smlua_model_util_get_id("lanhat_wing_geo"),
    metal = smlua_model_util_get_id("lanhat_metal_geo"),
    metalWing = smlua_model_util_get_id("lanhat_wingmetal_geo"),
}

local healthMeter = {
    label = {
        left = get_texture_info("gwainhp-half1"),
        right = get_texture_info("gwainhp-half2"),
    },
    pie = {
        [1] = get_texture_info("gwainhp-one"),
        [2] = get_texture_info("gwainhp-two"),
        [3] = get_texture_info("gwainhp-three"),
        [4] = get_texture_info("gwainhp-four"),
        [5] = get_texture_info("gwainhp-five"),
        [6] = get_texture_info("gwainhp-six"),
        [7] = get_texture_info("gwainhp-seven"),
        [8] = get_texture_info("gwainhp-eight"),
    }
}

local LANNEYCourseInfo = {
    top = TEX_LANNEY_COURSE_TOP,
    bottom = TEX_LANNEY_COURSE_BOTTOM,
}

local CSloaded = false
local function on_character_select_load()
CT_LANNEY = _G.charSelect.character_add("Lanney", "With a shy greeting and the whiff of fresh bread comes Lanney, a very kind but sheepish girl who works part-time at her family's café. Don't let her doughy facade fool you, though-behind it all is a strong-willed rock elemental who isn't afraid to fight for her friends.", "B. Bones Johnson/GeoExe", {r = 215, g = 135, b = 84}, E_MODEL_LANNEY009, CT_LUIGI, TEX_LANNEY_LIFE_ICON)
ALT_LANNEY = _G.charSelect.character_add_costume(

        CT_LANNEY,                     -- Original Character Number

        "Lanney (Alt Style)",                  -- Name (Save Name)

        "This is an alternate costume for Lanney based on one of her first outfits.", -- Description (Table containing Strings)

        "B. Bones Johnson/GeoExe",              -- Credit

        {r = 215, g = 135, b = 84},                                  -- Color (nil)

        E_MODEL_LANNEY001,              -- Model Info

        CT_LUIGI,                             -- Forced Character

        TEX_LANNEY_ALT_ICON                 -- Life Icon

    )
_G.charSelect.character_add_caps(E_MODEL_LANNEY009, CAPTABLE_LANNEY009)
_G.charSelect.character_add_caps(E_MODEL_LANNEY001, CAPTABLE_LANNEY001)
_G.charSelect.character_add_voice(E_MODEL_LANNEY009, VOICETABLE_LANNEY)
_G.charSelect.character_add_voice(E_MODEL_LANNEY001, VOICETABLE_LANNEY)
_G.charSelect.character_add_health_meter(CT_LANNEY, healthMeter)
_G.charSelect.character_add_costume_health_meter(CT_LANNEY, ALT_LANNEY, healthMeter)
_G.charSelect.character_add_course_texture(CT_LANNEY, LANNEYCourseInfo)
_G.charSelect.character_add_costume_course_texture(CT_LANNEY, ALT_LANNEY, LANNEYCourseInfo)

		charSelectLoaded = true
	end
	
	
	local function on_character_sound(m, sound)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_LANNEY then return _G.charSelect.voice.sound(m, sound) end
end
local function on_character_snore(m)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_LANNEY then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)