if not _G.charSelectExists then return end

local E_MODEL_GWAIN009 = smlua_model_util_get_id("gwain_009_geo") --Main Skin
local E_MODEL_GWAIN001 = smlua_model_util_get_id("gwain_001_geo") --Main Skin

local TEX_GWAIN_LIFE_ICON = get_texture_info("gwain-icon") -- Located in "textures"}
local TEX_GWAIN_ALT_ICON = get_texture_info("gwain-icon-alt")
local TEX_GWAIN_COURSE_TOP = get_texture_info("gwain-course-top")
local TEX_GWAIN_COURSE_BOTTOM = get_texture_info("gwain-course-bottom")

-- All Located in "sound"
local VOICETABLE_GWAIN = {
    [CHAR_SOUND_ATTACKED] = {"placehld_attacked1.ogg", "placehld_attacked2.ogg", "placehld_attacked3.ogg"},
    [CHAR_SOUND_COUGHING1] = "placehld_cough.ogg",
    [CHAR_SOUND_COUGHING2] = "placehld_cough.ogg",
    [CHAR_SOUND_COUGHING3] = "placehld_cough.ogg",
    [CHAR_SOUND_DOH] = "placehld_doh.ogg",
    [CHAR_SOUND_DROWNING] = "placehld_drown.ogg",
    [CHAR_SOUND_DYING] = "placehld_dead.ogg",
    [CHAR_SOUND_EEUH] = "placehld_hit.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "placehld_groundpound.ogg",
    [CHAR_SOUND_HAHA] = "placehld_haha.ogg",
    [CHAR_SOUND_HAHA_2] = "placehld_haha.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "placehld_starget.ogg",
    [CHAR_SOUND_HOOHOO] = "placehld_hoohoo.ogg",
    [CHAR_SOUND_HRMM] = "placehld_hrmm.ogg",
    [CHAR_SOUND_IMA_TIRED] = "placehld_tired.ogg",
    [CHAR_SOUND_MAMA_MIA] = "placehld_nope.ogg",
    [CHAR_SOUND_LETS_A_GO] = "placehld_levelstart.ogg",
    [CHAR_SOUND_ON_FIRE] = "placehld_burning.ogg",
    [CHAR_SOUND_OOOF] = "placehld_ooof.ogg",
    [CHAR_SOUND_OOOF2] = "placehld_ooof2.ogg",
    [CHAR_SOUND_PANTING] = "placehld_lowhealth.ogg",
    [CHAR_SOUND_PANTING_COLD] = "placehld_cold.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "placehld_punch_hoo.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "placehld_punch_wah.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "placehld_punch_yah.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = {"placehld_throw1.ogg", "placehld_throw2.ogg"},
    [CHAR_SOUND_SNORING1] = "placehld_snore1.ogg",
    [CHAR_SOUND_SNORING2] = "placehld_groundpound.ogg",
    [CHAR_SOUND_SNORING3] = {"placehld_groundpound.ogg", "placehld_snore1.ogg", "placehld_snore3.ogg"},
    [CHAR_SOUND_TWIRL_BOUNCE] = "placehld_spinjump.ogg",
    [CHAR_SOUND_UH] = "placehld_uh.ogg",
    [CHAR_SOUND_UH2] = "placehld_uh.ogg",
    [CHAR_SOUND_UH2_2] = "placehld_uh2_2.ogg",
    [CHAR_SOUND_WAAAOOOW] = "placehld_falling.ogg",
    [CHAR_SOUND_WAH2] = "placehld_jump1i.ogg",
    [CHAR_SOUND_WHOA] = "placehld_woah.ogg",
    [CHAR_SOUND_YAHOO] = "placehld_longjump.ogg",
    [CHAR_SOUND_YAWNING] = "placehld_yawn.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { "placehld_triplejump.ogg", "placehld_jump3.ogg", "placehld_longjump.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = { "placehld_jump2.ogg", "placehld_jump4.ogg", "placehld_jump6.ogg"},
    [CHAR_SOUND_HELLO] = "placehld_hello.ogg"
}

-- All Located in "actors"
local CAPTABLE_GWAIN009 = {
   normal = smlua_model_util_get_id("gwain_cap_geo"),
    wing = smlua_model_util_get_id("gwain_wingcap_geo"),
    metal = smlua_model_util_get_id("gwain_metalcap_geo"),
    metalWing = smlua_model_util_get_id("gwain_wingmetalcap_geo"),
}

local CAPTABLE_GWAIN001 = {
   normal = smlua_model_util_get_id("gwain001_cap_geo"),
    wing = smlua_model_util_get_id("gwain001_wingcap_geo"),
    metal = smlua_model_util_get_id("gwain001_metalcap_geo"),
    metalWing = smlua_model_util_get_id("gwain001_wingmetalcap_geo"),
}

local healthMeter = {
    label = {
        left = get_texture_info("gwainhp-half1"),
        right = get_texture_info("gwainhp-half2"),
    },
    pie = {
        [1] = get_texture_info("gwainhp-one"),
        [2] = get_texture_info("gwainhp-two"),
        [3] = get_texture_info("gwainhp-three"),
        [4] = get_texture_info("gwainhp-four"),
        [5] = get_texture_info("gwainhp-five"),
        [6] = get_texture_info("gwainhp-six"),
        [7] = get_texture_info("gwainhp-seven"),
        [8] = get_texture_info("gwainhp-eight"),
    }
}

local GWAINCourseInfo = {
    top = TEX_GWAIN_COURSE_TOP,
    bottom = TEX_GWAIN_COURSE_BOTTOM,
}

local CSloaded = false
local function on_character_select_load()
CT_GWAIN = _G.charSelect.character_add("Gwain", "The queen and ruler of Teora. Do not mess with her unless you're dying for a light beam to pierce through you. When duty calls, her demeanor is strict and authoritarian. But if you happen to catch her roaming about her castle on a day off, you'll find that she's rather slovenly.", "B. Bones Johnson/GeoExe", {r = 252, g = 223, b = 89}, E_MODEL_GWAIN009, CT_LUIGI, TEX_GWAIN_LIFE_ICON)
ALT_GWAIN = _G.charSelect.character_add_costume(

        CT_GWAIN,                     -- Original Character Number

        "Gwain (Alt Style)",                  -- Name (Save Name)

        "This is an alternate costume for Gwain, based on the outfit she wore in her debut episode.", -- Description (Table containing Strings)

        "B. Bones Johnson/GeoExe",              -- Credit

        {r = 253, g = 223, b = 101},                                  -- Color (nil)

        E_MODEL_GWAIN001,              -- Model Info

        CT_LUIGI,                             -- Forced Character

        TEX_GWAIN_ALT_ICON                 -- Life Icon

    )
_G.charSelect.character_add_caps(E_MODEL_GWAIN009, CAPTABLE_GWAIN009)
_G.charSelect.character_add_caps(E_MODEL_GWAIN001, CAPTABLE_GWAIN001)
_G.charSelect.character_add_voice(E_MODEL_GWAIN009, VOICETABLE_GWAIN)
_G.charSelect.character_add_voice(E_MODEL_GWAIN001, VOICETABLE_GWAIN)
_G.charSelect.character_add_health_meter(CT_GWAIN, healthMeter)
_G.charSelect.character_add_costume_health_meter(CT_GWAIN, ALT_GWAIN, healthMeter)
_G.charSelect.character_add_course_texture(CT_GWAIN, GWAINCourseInfo)
_G.charSelect.character_add_costume_course_texture(CT_GWAIN, ALT_GWAIN, GWAINCourseInfo)

	
	charSelectLoaded = true
end

		local function on_character_sound(m, sound)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_GWAIN then return _G.charSelect.voice.sound(m, sound) end
end
local function on_character_snore(m)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_GWAIN then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)