if not _G.charSelectExists then return end

local E_MODEL_LUNA009 = smlua_model_util_get_id("luna_009_geo") --Main Skin
local E_MODEL_LUNA001 = smlua_model_util_get_id("luna_001_geo") --Alt Skin

local TEX_LUNA_LIFE_ICON = get_texture_info("luna-icon") -- Located in "textures"
local TEX_LUNA_ALT_ICON = get_texture_info("luna-icon-alt") -- Located in "textures"
local TEX_LUNA_COURSE_TOP = get_texture_info("luna-course-top")
local TEX_LUNA_COURSE_BOTTOM = get_texture_info("luna-course-bottom")

local LUNACourseInfo = {
    top = TEX_LUNA_COURSE_TOP,
    bottom = TEX_LUNA_COURSE_BOTTOM,
}

-- All Located in "sound"
local VOICETABLE_LUNA = {
    [CHAR_SOUND_ATTACKED] = {"placehld_attacked1.ogg", "placehld_attacked2.ogg", "placehld_attacked3.ogg"},
    [CHAR_SOUND_COUGHING1] = "placehld_cough.ogg",
    [CHAR_SOUND_COUGHING2] = "placehld_cough.ogg",
    [CHAR_SOUND_COUGHING3] = "placehld_cough.ogg",
    [CHAR_SOUND_DOH] = "placehld_doh.ogg",
    [CHAR_SOUND_DROWNING] = "placehld_drown.ogg",
    [CHAR_SOUND_DYING] = "placehld_dead.ogg",
    [CHAR_SOUND_EEUH] = "placehld_hit.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "placehld_groundpound.ogg",
    [CHAR_SOUND_HAHA] = "placehld_haha.ogg",
    [CHAR_SOUND_HAHA_2] = "placehld_haha.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "placehld_starget.ogg",
    [CHAR_SOUND_HOOHOO] = "placehld_hoohoo.ogg",
    [CHAR_SOUND_HRMM] = "placehld_hrmm.ogg",
    [CHAR_SOUND_IMA_TIRED] = "placehld_tired.ogg",
    [CHAR_SOUND_MAMA_MIA] = "placehld_nope.ogg",
    [CHAR_SOUND_LETS_A_GO] = "placehld_levelstart.ogg",
    [CHAR_SOUND_ON_FIRE] = "placehld_burning.ogg",
    [CHAR_SOUND_OOOF] = "placehld_ooof.ogg",
    [CHAR_SOUND_OOOF2] = "placehld_ooof2.ogg",
    [CHAR_SOUND_PANTING] = "placehld_lowhealth.ogg",
    [CHAR_SOUND_PANTING_COLD] = "placehld_cold.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "placehld_punch_hoo.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "placehld_punch_wah.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "placehld_punch_yah.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = {"placehld_throw1.ogg", "placehld_throw2.ogg"},
    [CHAR_SOUND_SNORING1] = "placehld_snore1.ogg",
    [CHAR_SOUND_SNORING2] = "placehld_groundpound.ogg",
    [CHAR_SOUND_SNORING3] = {"placehld_groundpound.ogg", "placehld_snore1.ogg", "placehld_snore3.ogg"},
    [CHAR_SOUND_TWIRL_BOUNCE] = "placehld_spinjump.ogg",
    [CHAR_SOUND_UH] = "placehld_uh.ogg",
    [CHAR_SOUND_UH2] = "placehld_uh.ogg",
    [CHAR_SOUND_UH2_2] = "placehld_uh2_2.ogg",
    [CHAR_SOUND_WAAAOOOW] = "placehld_falling.ogg",
    [CHAR_SOUND_WAH2] = "placehld_jump1i.ogg",
    [CHAR_SOUND_WHOA] = "placehld_woah.ogg",
    [CHAR_SOUND_YAHOO] = "placehld_longjump.ogg",
    [CHAR_SOUND_YAWNING] = "placehld_yawn.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { "placehld_triplejump.ogg", "placehld_jump3.ogg", "placehld_longjump.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = { "placehld_jump2.ogg", "placehld_jump4.ogg", "placehld_jump6.ogg"},
    [CHAR_SOUND_HELLO] = "placehld_hello.ogg"
}

-- All Located in "actors"
local CAPTABLE_LUNA009 = {
   normal = smlua_model_util_get_id("luna_hat_geo"),
    wing = smlua_model_util_get_id("luna_winghat_geo"),
    metal = smlua_model_util_get_id("luna_metalhat_geo"),
    metalWing = smlua_model_util_get_id("luna_wingmetalhat_geo"),
}

local CAPTABLE_LUNA001 = {
   normal = smlua_model_util_get_id("luna_visor_geo"),
    wing = smlua_model_util_get_id("luna_wingvisor_geo"),
    metal = smlua_model_util_get_id("luna_metalvisor_geo"),
    metalWing = smlua_model_util_get_id("luna_wingmetalvisor_geo"),
}


local healthMeter = {
    label = {
        left = get_texture_info("gwainhp-half1"),
        right = get_texture_info("gwainhp-half2"),
    },
    pie = {
        [1] = get_texture_info("gwainhp-one"),
        [2] = get_texture_info("gwainhp-two"),
        [3] = get_texture_info("gwainhp-three"),
        [4] = get_texture_info("gwainhp-four"),
        [5] = get_texture_info("gwainhp-five"),
        [6] = get_texture_info("gwainhp-six"),
        [7] = get_texture_info("gwainhp-seven"),
        [8] = get_texture_info("gwainhp-eight"),
    }
}

local CSloaded = false
local function on_character_select_load()
CT_LUNA = _G.charSelect.character_add("Luna", "Genius inventor, playboy millionaire, and the antagonist of this story, she's a cheeky diva with the mechanical arms to back up her ego. She loves to toy with the main crew, often throwing light jabs at the warriors, but she can be a DEVASTATING threat if you get on her bad side. (So try not to.)", "B. Bones Johnson/GeoExe", {r = 58, g = 60, b = 68}, E_MODEL_LUNA009, CT_LUIGI, TEX_LUNA_LIFE_ICON)
ALT_LUNA = _G.charSelect.character_add_costume(

        CT_LUNA,                     -- Original Character Number

        "Luna (Alt Style)",                  -- Name (Save Name)

        "This is an alternate costume for Luna, based on an outfit she wore in the pilot episode.", -- Description (Table containing Strings)

        "B. Bones Johnson/GeoExe",              -- Credit

        {r = 62, g = 59, b = 63},                                  -- Color (nil)

        E_MODEL_LUNA001,              -- Model Info

        CT_LUIGI,                             -- Forced Character

        TEX_LUNA_ALT_ICON                 -- Life Icon

    )
_G.charSelect.character_add_caps(E_MODEL_LUNA009, CAPTABLE_LUNA009)
_G.charSelect.character_add_caps(E_MODEL_LUNA001, CAPTABLE_LUNA001)
_G.charSelect.character_add_voice(E_MODEL_LUNA009, VOICETABLE_LUNA)
_G.charSelect.character_add_voice(E_MODEL_LUNA001, VOICETABLE_LUNA)
_G.charSelect.character_add_health_meter(CT_LUNA, healthMeter)
_G.charSelect.character_add_costume_health_meter(CT_LUNA, ALT_LUNA, healthMeter)
_G.charSelect.character_add_course_texture(CT_LUNA, LUNACourseInfo)
_G.charSelect.character_add_costume_course_texture(CT_LUNA, ALT_LUNA, LUNACourseInfo)



	charSelectLoaded = true
end



	local function on_character_sound(m, sound)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_LUNA then return _G.charSelect.voice.sound(m, sound) end
end
local function on_character_snore(m)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_LUNA then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)